# dbmarkers

Utility to incoporate tempo markers to various DAWs and musical apps.

Downbeat markers for a song are automatically generated by the [madmom project's DBNDownBeatTracker utility](https://github.com/CPJKU/madmom)

 The DBNDownBeatTracker program detects all beats and downbeats in an audio file according to the method described in:

    "Joint Beat and Downbeat Tracking with Recurrent Neural Networks"
    Sebastian Böck, Florian Krebs and Gerhard Widmer.
    Proceedings of the 17th International Society for Music Information
    Retrieval Conference (ISMIR), 2016.

```bash   
 $ DBNDownBeatTracker single INFILE [-o OUTFILE]
```

The resulting OUTFILE is a tab separated file of durations in seconds and the beats sequence (1,2,3,4)

This utility takes this OUTFILE and incrporates this information into DAWs and musical apps.

List of supported DAWs and musical apps:

* [Transcribe!](https://www.seventhstring.com/xscribe/overview.html)
* [Reaper](https://www.reaper.fm/)

# Installation

```bash
pip install dbmarkers
```

# Usage

## Transcribe

```bash
markers-transcribe --console generate --input-file markers_from_dbn_beat_tracker.txt  --output-file your_transcribe_file.xsc
```

## Reaper

```bash
markers-reaper --console generate --input-file markers_from_dbn_beat_tracker.txt  --output-file your_reaper_project_file.csv
```

Project markers must be imported in Reaper from the Dialog "View > Region/Marger Manager", clicking on the Options Button and selecting "Import regions/markers (replace existing) ..."

![Reaper Project Markers inport](doc/images/img/reaper_import_markers.png "Import project markers into a Reaper Song")

To convert Project Markers into a Tempo map, execute the action "SWS/BR: Convert project markers to tempo. A dialog will open. Usually, time signature is 4/4 and `DBNDownBeatTracker` includes 4 beats per bar.
